/*	Lanch.win	version	0.20	*/
/*		Copyrigth 1999 Rick	*/

#include	<corlib.h>
#include	<winop.h>
#include	<parts.h>
#include	<HS_wlib.h>
#include	<string.h>

#define	ICONH	( 16 * 10 )
#define	ICONHWORD	( ( ICONH + 15 ) >> 4 )
#define	ICONV	16
#define	ICONBUFSIZE	ICONHWORD * ICONV
#define	VICONH	16
#define	VICONHWORD	1
#define	VICONV	( 16 * 10 )

int	WindowHeapSize= 0;

static unsigned short	iconbuf[ICONBUFSIZE * 2];
static Sheet	icon= {
					ICONH,
					ICONV,
					ICONHWORD,
					iconbuf,
					iconbuf + ICONBUFSIZE
				};
static unsigned int	work;
static int	menunum[10], but= -1, vartical= FALSE;
static unsigned char	*rsexestr[10], *menustr[10][8], title[2048];

static unsigned char *
getword( dest, src )
unsigned char	*dest;
unsigned char	*src;
{
	while( *src && *src > ' ' && *src != ',' ){
		*dest++= *src++;
	}
	*dest= NULL;
	while( *src == ' ' || *src == '\t' || *src == ',' ){
		src++;
	}
	return src;
}


static void
comexe( num )
int	num;
{
	int	i;
	unsigned char	execom[128],
			cmdline[128],
			file[128],
			temp[128],
			*ptr= rsexestr[but],
			mode= 'e';

	*execom= NULL;
	*cmdline= NULL;
	*file= NULL;

	for( i= 0; i < num; i++ ){
		ptr= strchr( ptr, '\n' );
		if( !ptr )	break;
		ptr++;
	}

	if( !ptr || !strchr( ptr, '\n' ) )	return;

	ptr= getword( temp, ptr );			/* drop title string */
	mode= *ptr;							/* get mode unsigned character */

	ptr= getword( execom, ptr + 2 );	/* get program name */

	i= FALSE;							/* file get flag */

	while( *ptr != '\n' ){				/* end of commandline */
		ptr= getword( temp, ptr );

		if( mode == 's' && *temp != '-' && !i ){
			strcpy( file, temp );
			i= TRUE;
		}else {
			strcat( cmdline, " " );
			strcat( cmdline, temp );
		}
	}

	if( mode == 's' ){
		UserSendExec( execom, cmdline, file );
	}else if( mode == 'r' ){
		WindowScreenQuit();
		WindowLoadExec( execom, cmdline, NULL, NULL );
		WindowScreenInit();
	}else{
		WindowLoadExec( execom, cmdline, NULL, ConsoleChar );
	}
}


static int
popupmenu( wp, info )
WindowID	wp;
EventInfo	*info;
{
	int	num, px, py;

	WindowGetScreenPosition( wp, &px, &py );
	px+= info->x;
	py+= info->y;
	num= PopUpMenu( px-1, py, (char**)(menustr[but]), menunum[but], 12 );
	if( num >= 0 && num < 8 ){
		comexe( num );
	}
	return	TRUE;
}


static int
Exec( wp, info )
WindowID	wp;
EventInfo	*info;
{
	DrawBuf	dbuf[2];

	switch( info->option ){
	case EventOpen:
		WindowRedraw( wp );
		WindowSetEventAttr( wp, EventAttrDefault|EventIntervalON );
		return	TRUE;

	case EventRedraw:
		DrawSetClear( dbuf, 0 );
		DrawSetPut( dbuf + 1, 0, 0, &icon );
		WindowDraw( wp, dbuf, 2 );
		return	TRUE;

	case EventClose:
		WindowClose( wp );
		WindowConnectionClose();
		return	TRUE;

	case EventInterval:
		if( IntervalWait( 200, &work ) ){
			if( HS_WindowGetLast( wp ) )	WindowPop( wp );
			return TRUE;
		}
		return FALSE;

	case EventMouseSwitch:
		if( info->LeftON && but < 0 ){
			if( vartical ){
				but= info->y / 16;
			}else {
				but= info->x / 16;
			}
			if( but > 9 ){ 
				but= -1; 
				return TRUE;
			}
			if( vartical ){
				DrawSetLine( dbuf, 0, but * 16, 15, but * 16 + 15,
								1 + OptionXor, OptionFill );
			}else {
				DrawSetLine( dbuf, but * 16, 0, but * 16 + 15, 15,
								1 + OptionXor, OptionFill );
			}
			WindowDraw( wp, dbuf, 1 );
			return TRUE;
		}else if( info->LeftOFF && but >= 0 ){
			comexe( 0 );
			DrawSetPut( dbuf, 0, 0, &icon );
			WindowDraw( wp, dbuf, 1 );
			but= -1;
			return TRUE;
		}else if( info->RightON ){
			if( vartical ){
				but= info->y / 16;
			}else {
				but= info->x / 16;
			}
			if( but > 9 )	but= 9;
			popupmenu( wp, info );
			but= -1;
			return TRUE;
		}
	}
	return	FALSE;
}


int
WindowMain( argc, argv )
int	argc;
char	**argv;
{
	Sheet	*temp;
	ClipClass	clip= { 0, 0, 16 * 10 - 1, 16 - 1 };
	int	x= 160, y= 30;
	int	i, j;
	unsigned char	lic[]="licon ", lex[]="lexe ",
			*ttl, *ptr;

	argc= AnalyzeArgs( argc, argv, &x, &y, NULL, NULL );
	while( --argc ){
		if( **++argv == '-' && (*argv)[1] == 'V' )	vartical= TRUE;
	}

	if( vartical ){
		icon.h= VICONH;
		icon.v= VICONV;
		icon.hword= VICONHWORD;
		clip.x2= 16 - 1;
		clip.y2= 16 * 10 - 1;
	}

	{ unsigned short	*clrptr= icon.buf1;
		for( i= 0; i < ICONBUFSIZE * 2; i++ ){
			*clrptr++= 0;
		}
	}

	ttl= title;

	for( i= 0; i < 10; i++ ){
		menunum[i]= 0;
		lex[4]= lic[5]= i + '0';

		temp= WindowGetResource( "Pattern", lic, "lanch" );
		if( temp ){
			if( vartical ){
				SheetCopy( &icon, &clip, 0, i * 16, temp );
			}else {
				SheetCopy( &icon, &clip, i * 16, 0, temp );
			}
		}

		rsexestr[i]= WindowGetResource( "String", lex, "lanch" );
		if( !( ptr= rsexestr[i] ) )	continue;

		for( j= 0; j < 8; j++ ){
			menunum[i]++;			/* popup menu increment */
			menustr[i][j]= ttl;		/* get title */
			while( *ptr > ' ' && *ptr != ',' ){
				*ttl++= *ptr++;
			}
			*ttl++= NULL;
			ptr= strchr( ptr, '\n' ) + 1;
			if( !*ptr )	break;
		}
	}

	if( vartical ){
		WindowTitleOpen( x, y, 16+2, 160+2, NULL, "", NULL, Exec );
	}else {
		WindowTitleOpen( x, y, 160+2, 16+2, NULL, "LAUNCHER", Close, Exec );
	}
	return TRUE;
}
